#include <netdb.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include "globals.h"

int main(int argc, char *argv[])
{
    if (argc != 2)
    {
        printf("*** Usage: <IP address of server>\n");
        return -1;
    }

    int socket_fd = socket(AF_INET, SOCK_STREAM, 0);
    if (socket_fd < 0)
    {
        perror("*** Error: socket()");
        return -2;
    }

    struct sockaddr_in server_address;
    memset(&server_address, '0', sizeof(server_address));

    server_address.sin_family = AF_INET;
    server_address.sin_port   = htons(SERVER_PORT);

    char *ip_address = argv[1];
    if (inet_pton(AF_INET, ip_address, &server_address.sin_addr) <= 0)
    {
        perror("*** Error: inet_pton()");
        return -3;
    }

    if (connect(socket_fd,
                (struct sockaddr *)&server_address,
                sizeof(server_address)) < 0)
    {
        perror("*** Error: connect()");
        return -4;
    }

    char buffer[BUFFER_SIZE];
    memset(buffer, '0', sizeof(buffer));

    int n = read(socket_fd, buffer, sizeof(buffer)-1);
    if (n > 0)
    {
        buffer[n] = 0;
        printf("Client received %s", buffer);
    }
    else perror("*** Error: read()");

    return 0;
}
